#include<dos.h>
#include<conio.h>
#include<string.h>
#include<stdlib.h>
#include<graphics.h>

main()
 {
  int gd = DETECT, gm, fill[6] = { 155, 180, 230, 280, 355, 455 };
  int flag, partsize[5] = { 32, 64, 64, 96, 128 };
  int i, deall = 128, alloc[5] = { 0, 0, 0, 0, 0 };
  char s[50], size[50];
  struct link
   {
    int jobsize;
    struct link *next;
   }
  *start, *node, *job, *prev;
  randomize();
  initgraph(&gd, &gm, "c:/tc/bgi");
  setcolor(YELLOW);
  outtextxy(250, 40, "Simulation of Static Memory Management Technique");
  outtextxy(250, 50, "");
  setcolor(WHITE);
  outtextxy(10, 10, "Jobs in queue : ");

// Memory Map

  outtextxy(10, 50, "0 KB");
  rectangle(70, 50, 170, 450);
  line(70, 150, 170, 150);
  setfillstyle(11, WHITE);
  floodfill(80, 60, WHITE);
  outtextxy(180, 100, "OS - 128KB");
  line(70, 175, 170, 175);
  outtextxy(10, 150, "128 KB");
  line(70, 225, 170, 225);
  outtextxy(10, 175, "160 KB");
  line(70, 275, 170, 275);
  outtextxy(10, 225, "224 KB");
  line(70, 350, 170, 350);
  outtextxy(10, 275, "288 KB");
  line(70, 450, 170, 450);
  outtextxy(10, 350, "384 KB");
  outtextxy(10, 450, "512 KB");

// Allocation Table

  rectangle(300, 140, 600, 350);
  for (i = 0;i < 6;i++)
   line(300, 140 + (35 * i), 600, 140 + (35 * i));
  line(320, 140, 320, 350);
  line(395, 140, 395, 350);
  line(470, 140, 470, 350);
  outtextxy(306, 155, "#");
  outtextxy(325,155,"Location");
  outtextxy(415,155,"Size");
  outtextxy(520,155,"Status");
  for (i = 0;i < 5;i++)
   {
    itoa(i + 1, size, 10);
    outtextxy(306, 190 + (i * 35), size);
    itoa(deall, size, 10);
    strcat(size, "K");
    outtextxy(340, 190 + (i * 35), size);
    deall += partsize[i];
    itoa(partsize[i], size, 10);
    strcat(size, "K");
    outtextxy(415, 190 + (i * 35), size);
    outtextxy(510, 190 + (i * 35), "  Empty");
   }

// Job allocation and deallocation

  start = new(struct link);
  start->jobsize = random(119) + 10;
  start->next = NULL;
  while (!kbhit())
   {
    i = 0;
    setviewport(150, 0, 639, 30, 1);
    clearviewport();
    setviewport(0, 0, 639, 479, 1);
    job = start;
    while (job)
     {
      itoa(job->jobsize, size, 10);
      outtextxy(150 + i, 10, size);
      i += 30;
      prev = job;
      job = job->next;
     }
    job = prev;
    node = new(struct link);                  // new job
    node->jobsize = random(119) + 10;
    node->next = NULL;
    job->next = node;
    job = node;
    itoa(job->jobsize, size, 10);
    outtextxy(150 + i, 10, size);
    deall = random(5);                        // Deallocation of partition
    if (alloc[deall])
     {
      alloc[deall] = 0;
      setfillstyle(1, BLACK);
      floodfill(80, fill[deall], WHITE);
      i = (fill[deall] + fill[deall + 1]) / 2;
      setviewport(175, i, 225, i + 20, 1);
      clearviewport();
      setviewport(510, 190 + (deall * 35), 590, 205 + (deall * 35), 1);
      clearviewport();
      setviewport(300, 400, 639, 479, 1);
      clearviewport();
      strcpy(size, "Deallocated partition ");
      itoa(deall + 1, s, 10);
      strcat(size, s);
      outtextxy(0, 0, size);
      setviewport(0, 0, 639, 479, 1);
      outtextxy(510, 190 + (deall * 35), "  Empty");
      delay(1500);
     }
    job = start;
    flag = 0;
    while ((!flag) && (job))                // Allocation of job
     {
      flag = 0;
      for (deall = 0;deall < 5;deall++)
       if ((job->jobsize <= partsize[deall]) && (!alloc[deall]))
	{
	 alloc[deall] = 1;
	 setfillstyle(11,deall+1);
	 floodfill(80,fill[deall],WHITE);
	 if (job == start)
	  start = start->next;
	  else prev->next = job->next;
	 flag = 1;
	 i = (fill[deall] + fill[deall + 1]) / 2;
	 setviewport(175, i, 225, i + 20, 1);
	 itoa(job->jobsize, size, 10);
	 strcat(size, "KB");
	 outtextxy(5, 0, size);
	 setviewport(510, 190 + (deall * 35), 590, 205 + (deall * 35), 1);
	 clearviewport();
	 setviewport(300, 400, 639, 479, 1);
	 clearviewport();
	 strcpy(s, "Allocated job of ");
	 strcat(s, size);
	 strcat(s, " to partition ");
	 itoa(deall + 1, size, 10);
	 strcat(s, size);
	 outtextxy(0, 0, s);
	 setviewport(0, 0, 639, 479, 1);
	 outtextxy(510, 190 + (deall * 35), "Allocated");
	 break;
	}
       prev = job;
       job = job->next;
     }
    delay(1500);
   }
  closegraph();
  return 0;
 }
